from scapy.all import *

def convert_sciper_to_ip(sciper):

	"""Function to convert 6-char SCIPER (input as string) to IP address format accepted
	by Scapy. Use this function when replacing the IP address in your packet."""

	n = 2
	split_sciper = [sciper[i:i+n] for i in range(0, len(sciper), n)]
	return "00." + '.'.join(split_sciper)

def modify_pcap(input_pcap_file, output_pcap_file):

	"""Complete this function! Function that takes in input_pcap_file, modifies the DNS response, and 
	creates an output_pcap_file. output_pcap_file contains all the original records
	as input_pcap_file and the modified DNS response."""

	# Store the packets you want to write to output_pcap_file in new_pkts
	new_pkts = []

	# rdpcap reads the input file and obtains the list of packets in the file
	pkts = rdpcap(input_pcap_file)


	############################################
	# Insert your code below. Steps to follow:

	# 1. Iterate through each packet in pkts
	# 2. Check if the packet is a DNS response for the grading server. If it is not, add to new_pkts.
	# 3. Store the packet's timestamp for use in Step 7. You can get the timestamp with packet.time .
	# 4. DNS responses contain Resource Records, which hold the information you require. Look
	#    at the resource records present in the packet.
	# 5. When you find the resource record of type 'A' and the content to be the IP address,
	#    change the IP address to your SCIPER. Use the function convert_sciper_to_IP() to convert 
	#	 your SCIPER to the appropriate format for Scapy.
	# 6. The IP and UDP layers of the packet contain two fileds: length (len) and checksum (chksum).
	#    This allows the recepient to check that the packet was not modified. Modify the fields
	#    for IP and UDP layers in your new packet. You need not modify the data length field in the DNS record.
	# 7. Scapy will change the timestamp of your packet to the newest timestamp, when you perform
	#    the checksum recalculation. Edit the modified packet's timestamp with the original timestamp.
	#     modified_packet.time = packet.time 
	# 8. Add the modified packet to new_pkts.
	###########################################


	# wrpcap writes the packets in new_pkts to output_pcap_file
	wrpcap(output_pcap_file, new_pkts)


if __name__ == "__main__":

	input_pcap_file = "pcap2.pcap"
	output_pcap_file = "pcap2new.pcap"
	modify_pcap(input_pcap_file, output_pcap_file)